### *** This interface provides Binary Compatibility only, not Source Compatibility ***

Package com.sas.services.information.metadata

# Interface ConnectionInterface

All Superinterfaces:
  `MetadataInterface`, `PublicObjectInterface`, `Remote`

All Known Subinterfaces:
  `COMConnectionInterface`, `ProxyInterface`, `SASClientConnectionInterface`, `TCPIPConnectionInterface`

All Known Implementing Classes:
  com.sas.services.information.metadata.OMRConnection, `OMRProxy`, com.sas.services.information.metadata.OMRTCPIPConnection

@SASScope("ALL") @BinaryCompatibilityOnly public interface ConnectionInterface extends MetadataInterface

- ## Field Summary

  ### Fields inherited from interface com.sas.services.information.metadata.MetadataInterface

  `METADATA_STATE_DELETED, METADATA_STATE_DESTROYED, METADATA_STATE_NEW, METADATA_STATE_NORMAL, PERMISSION_READMETADATA, PERMISSION_WRITEMETADATA`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addProvider(ServerInterface provider)`
  Add a provider server which can connect to the listening source server over this connection.
  `String`
  `getApplicationProtocol()`
  Get the application protocol String.
  `String`
  `getAuthenticationType()`
  Get the authentication type string for the connection.
  `String`
  `getCommunicationProtocol()`
  Get the communication protocol.
  `String`
  `getDomain()`
  Get the authentication domain for this connection.
  `List<MetadataInterface>`
  `getProperties()`
  Get the properties for connection.
  `List`
  `getProviders()`
  Get the list of servers that can connect to the listener over this connection.
  `ServerInterface`
  `getSource()`
  Get the server to which a client connects using this connection information.
  `void`
  `removeProvider(ServerInterface provider)`
  Remove a provider server from the providers list.
  `void`
  `setApplicationProtocol(String appProtocol)`
  Set the application protocol string.
  `void`
  `setAuthenticationType(String authType)`
  Set the authentication type string.
  `void`
  `setCommunicationProtocol(String commProtocol)`
  Set the communication protocol.
  `void`
  `setDomain(String domain)`
  Set the authentication domain name for this connection.
  `void`
  `setProperty(ConnectionInterface objCon, String value, String PropName)`
  Set the value to the property of connection.
  `void`
  `setProviders(List providers)`
  Set the list of provider servers that can connect to the source server over this connection.
  `void`
  `setSource(ServerInterface server)`
  Set the server which is listening on this connection.

  ### Methods inherited from interface com.sas.services.information.metadata.MetadataInterface

  `add, addAccessControl, addAttribute, addAttributes, addDocument, addExtension, addGroup, addImplementor, addKeyword, addNoteTextStore, addNoteTextStore, addObjectProperty, addObjectProperty, addPermissions, addPrompt, addPropertySet, addRemark, addResponsibleParty, addTransactionListener, addUsedByPrototype, checkin, checkout, commit, copyTo, countAssociatedObjects, delete, deleteAttribute, deleteAttributes, destroy, getAccessControls, getAttribute, getAttributes, getAuthorizationUtil, getCreateDate, getCreatedBy, getDescription, getDocuments, getEntityKey, getEntityURL, getExtensions, getGroups, getGUID, getIdentities, getImplementors, getKeywords, getLockedBy, getModifiedBy, getModifyDate, getNoteTextStore, getNoteTextStores, getNoteTextStoresByRole, getObjectProperties, getParent, getParentPath, getParents, getPath, getPaths, getPermission, getPermissions, getPermissions, getPreviousVersionNames, getPrimaryPropertyGroup, getPrompt, getPrompts, getPropertyBag, getPropertySets, getRemarksList, getReposId, getRepository, getRepositoryEntity, getRepositoryName, getReposKey, getResponsibleParties, getState, getTrackingId, getType, getUsageVersion, getUsedByPrototypes, getUsingPrototype, getVersion, isAuthorized, isCompatible, isDeleted, isDestroyed, isObjectAlive, isReadCompatible, mapNameToFilesystem, mapUrlToFilesystem, moveTo, newServiceObject, refresh, removeAccessControl, removeDocument, removeExtension, removeGroup, removeImplementor, removeKeyword, removeNoteTextStore, removeObjectProperty, removePermissions, removePrompt, removePropertySet, removeResponsibleParty, removeResponsiblePartyByIdentity, removeUsedByPrototype, rollback, setAttribute, setAttributes, setDeleted, setDescription, setDocuments, setExtensions, setGroups, setGUID, setKeywords, setName, setNoteTextStores, setObjectProperties, setPermission, setPrimaryPropertyGroup, setPrompt, setPrompts, setRemarksList, setRepository, setUsingPrototype, startTransaction, toByteArray, transactionEvent, uncheckout, update, updateFromBag, version`

  ### Methods inherited from interface com.sas.services.information.publicobject.PublicObjectInterface

  `addProcessorInterface, getContainer, getIdentifier, getName, getObjectURI, getPathUrl, getProcessorInterface, getTypeDescriptor`

- ## Method Details

  - ### getAuthenticationType

    String getAuthenticationType() throws ServiceException, RemoteException
    Get the authentication type string for the connection.
    Returns:
      The authentication type string.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setAuthenticationType

    void setAuthenticationType(String authType) throws ServiceException, RemoteException
    Set the authentication type string.
    Parameters:
      `authType` - The authentication type string.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getCommunicationProtocol

    String getCommunicationProtocol() throws ServiceException, RemoteException
    Get the communication protocol.
    Returns:
      The communication protocol.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setCommunicationProtocol

    void setCommunicationProtocol(String commProtocol) throws ServiceException, RemoteException
    Set the communication protocol.
    Parameters:
      `commProtocol` - The communication protocol string.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getProperties

    List<MetadataInterface> getProperties() throws ServiceException, RemoteException
    Get the properties for connection.
    Returns:
      The list of properties.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getApplicationProtocol

    String getApplicationProtocol() throws ServiceException, RemoteException
    Get the application protocol String.
    Returns:
      The application protocol string.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setApplicationProtocol

    void setApplicationProtocol(String appProtocol) throws ServiceException, RemoteException
    Set the application protocol string.
    Parameters:
      `appProtocol` - The application protocol string.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getDomain

    String getDomain() throws ServiceException, RemoteException
    Get the authentication domain for this connection.
    Returns:
      The authentication domain name for this connection.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setDomain

    void setDomain(String domain) throws ServiceException, RemoteException
    Set the authentication domain name for this connection.
    Parameters:
      `domain` - The new domain name.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getSource

    ServerInterface getSource() throws ServiceException, RemoteException
    Get the server to which a client connects using this connection information.
    Returns:
      The server which is listening on this connection.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setSource

    void setSource(ServerInterface server) throws ServiceException, RemoteException
    Set the server which is listening on this connection.
    Parameters:
      `server` - The server a client connects to on this connection.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getProviders

    List getProviders() throws ServiceException, RemoteException
    Get the list of servers that can connect to the listener over this connection.
    Returns:
      The list of provider servers that can connect to the source server over this connection.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### addProvider

    void addProvider(ServerInterface provider) throws ServiceException, RemoteException
    Add a provider server which can connect to the listening source server over this connection.
    Parameters:
      `provider` - A Server which can connect to the source over this connection.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### removeProvider

    void removeProvider(ServerInterface provider) throws ServiceException, RemoteException
    Remove a provider server from the providers list.
    Parameters:
      `provider` - A server to remove from the providers list.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setProviders

    void setProviders(List providers) throws ServiceException, RemoteException
    Set the list of provider servers that can connect to the source server over this connection.
    Parameters:
      `providers` - A List of `ServerInterface` objects that can connect to the source server over this connection.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setProperty

    void setProperty(ConnectionInterface objCon, String value, String PropName) throws RemoteException, com.sas.metadata.remote.MdException
    Set the value to the property of connection.
    Parameters:
      `objCon` - Connection object, It can be SASClientConnection or TCPIPConnection.
      `value` - to be assigned to property.
      `PropName` - Name of property for which value will be changed.
    Throws:
      `RemoteException` - In the event of remote object failure.
      `com.sas.metadata.remote.MdException` - If a metadata error occurs.